unit Find;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MPHexEditor;

type
  TFindForm = class(TForm)
    Label2:      TLabel;
    Label1:      TLabel;
    PatternMode: TComboBox;
    Pattern:     TEdit;
    Label3:      TLabel;
    DirectionUp: TRadioButton;
    DirectionDown: TRadioButton;
    FindExit:    TButton;
    FindFind:    TButton;
    MatchCase:   TCheckBox;
    procedure FindFindClick(Sender: TObject);
    procedure PatternChange(Sender: TObject);
    procedure FindExitClick(Sender: TObject);
    procedure PatternModeChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FindForm: TFindForm;

implementation

uses main;

{$R *.dfm}


procedure TFindForm.FindExitClick(Sender: TObject);
begin
  FindForm.Close;
end;

procedure TFindForm.FindFindClick(Sender: TObject);
var
  I, P: integer;
  temp: string;
begin
  if PatternMode.ItemIndex = 0 then
  begin
    if (length(Pattern.Text) < StrToInt(MainForm.EditLength.Text)) or
      (MainForm.StringsList.Items.Count = 0) then
    begin
      ShowMessage('Please populate strings of an appropriate minimal size first');
      MainForm.Tabs.TabIndex := 1;
      MainForm.Tabs.OnChange(Sender);
      MainForm.EditLength.SetFocus;
    end
    else
    if DirectionUp.Checked then
    begin
      if MainForm.StringsList.ItemIndex - 1 < 0 then
      begin
        ShowMessage('Search pattern not found');
      end
      else
      begin
        for I := MainForm.StringsList.ItemIndex - 1 downto 0 do
        begin
          if MatchCase.Checked then
          begin
            P := Pos(Pattern.Text, MainForm.StringsList.Items.Strings[I]);
          end
          else
          begin
            P := Pos(lowercase(Pattern.Text),
              lowercase(MainForm.StringsList.Items.Strings[I]));
          end;
          if P <> 0 then
          begin
            MainForm.StringsList.ItemIndex := I;
            MainForm.StringsList.SetFocus;
            break;
          end;
          if I = 0 then
          begin
            ShowMessage('Search pattern not found');
          end;
        end;
      end;
    end
    else
    begin
      if MainForm.StringsList.ItemIndex + 1 = MainForm.StringsList.Items.Count then
      begin
        ShowMessage('Search pattern not found');
      end
      else
      begin
        for I := MainForm.StringsList.ItemIndex +
          1 to MainForm.StringsList.Items.Count - 1 do
        begin
          if MatchCase.Checked then
          begin
            P := Pos(Pattern.Text, MainForm.StringsList.Items.Strings[I]);
          end
          else
          begin
            P := Pos(lowercase(Pattern.Text),
              lowercase(MainForm.StringsList.Items.Strings[I]));
          end;
          if P <> 0 then
          begin
            MainForm.StringsList.ItemIndex := I;
            MainForm.StringsList.SetFocus;
            break;
          end;
          if I = MainForm.StringsList.Items.Count - 1 then
          begin
            ShowMessage('Search pattern not found');
          end;
        end;
      end;
    end;
  end
  else
  begin
    temp := Pattern.Text;
    ConvertHexToBin(PChar(Pattern.Text), PChar(temp), Length(Pattern.Text), False, I);
    SetLength(temp, I);
    MainForm.HexDump.PrepareFindReplaceData(temp, False, False);
    P := MainForm.HexDump.Find(PChar(temp), length(temp),
      MainForm.HexDump.SelStart + 1, MainForm.HexDump.DataSize, False);
    if P > 0 then
    begin
      MainForm.HexDump.SelStart := P;
      MainForm.HexDump.SelEnd   := P + length(temp) - 1;
    end
    else
      ShowMessage('Search pattern not found');
  end;
end;

procedure TFindForm.PatternChange(Sender: TObject);
begin
  if Pattern.Text = '' then
  begin
    FindFind.Enabled := False;
  end
  else
  begin
    FindFind.Enabled := True;
  end;

end;

procedure TFindForm.PatternModeChange(Sender: TObject);
begin
  if PatternMode.ItemIndex = 1 then
  begin
    MatchCase.Enabled     := False;
    DirectionUp.Enabled   := False;
    DirectionDown.Checked := True;
  end
  else
  begin
    MatchCase.Enabled   := True;
    DirectionUp.Enabled := True;
  end;

end;

end.
